stages:
  - build
  - test
  - deploy

build_assets:
  stage: build
  image: node:20
  when: always
  script:
    # "npm ci" is preferred in automated environments,
    # but only works when a package-lock.json exists!
    - npm ci --cache .npm --prefer-offline
    - npm run build:production
  artifacts:
    name: Site_Assets
    paths:
      - ./packages/site-distribution/Resources/Public
    expire_in: 1h
    untracked: true

package_install:
  stage: build
  image: composer:2.4
  when: always
  script:
    # @todo: Once we have a TYPO3 recommended image containing composer and all requirements
    #        this should be replaced by a regular "composer install"
    - composer install --ignore-platform-reqs
  artifacts:
    name: Site_Vendor
    paths:
      - ./vendor
    expire_in: 1h

phpstan:
  stage: test
  image: php:8.2-cli-alpine
  when: always
  needs:
    - package_install
  script:
    - echo "memory_limit=1024M" >> $PHP_INI_DIR/conf.d/memory.ini
    - ./vendor/bin/phpstan analyse -c .phpstan.neon --no-progress

php_cs_fixer:
  stage: test
  image: php:8.2-cli-alpine
  when: always
  needs:
    - package_install
  script:
    - ./vendor/bin/php-cs-fixer fix --dry-run --diff

.add_ssh: &add_ssh
  image: php:8.2-cli-alpine
  stage: deploy
  when: on_success

deploy_to_staging:
  <<: *add_ssh
  environment: staging
  resource_group: staging
  before_script:
    # Add packages required to connect via ssh to copy files
    - apk update && apk add openssh-client rsync bash
    # Run ssh-agent (inside the build environment)
    - eval $(ssh-agent -s)
    # Add ssh key variable KEY_STAGING in the project settings -> CI/CD -> Variables
    - echo "$KEY_STAGING" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh
    - echo "$SSH_KNOWN_HOSTS" > ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts
  script:
    # Example command to deploy to "staging" environment, see deploy.yaml
    - ./vendor/bin/dep deploy -vvv staging
    - ./vendor/bin/dep --version
  rules:
    - if: '$CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH'
      when: on_success

deploy_to_production:
  <<: *add_ssh
  environment: production
  resource_group: production
  before_script:
    # Add packages required to connect via ssh to copy files
    - apk update && apk add openssh-client rsync bash
    # Run ssh-agent (inside the build environment)
    - eval $(ssh-agent -s)
    # Add ssh key variable KEY_PRODUCTION in the project settings -> CI/CD -> Variables
    - echo "$KEY_PRODUCTION" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh
    - echo "$SSH_KNOWN_HOSTS" > ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts
  script:
    # Example command to deploy to "production" environment, see deploy.yaml
    - ./vendor/bin/dep deploy -vvv production
    - ./vendor/bin/dep --version
  rules:
    - if: '$CI_COMMIT_TAG'
      when: on_success
